function [c,I]=sort(a,DIM)
%sort: sort in ascending order

%second parameter should be of type double
DIM=double(DIM);
hi=double(a);lo=double(a-hi);
if nargin==1
    %sort according the first part; if they are equal, consider the lower bits
    [c,I]=sortrows([hi lo],[1 2]);
    %send back a true extended value
    %original c=a(I,:); %does not work due to a bug somewhere in matlab
    %the workaround: invoke directly the subsref routine
    SS.type='()';SS.subs={I ':'};c=subsref(a,SS);
else
    %we only deal with two-dimensional objects, so let's consider both cases
    %and disregard the others
    switch DIM
        case 1
            %standard order; call the routine without the DIM parameter
            [c,I]=sort(a);
        case 2
            %call the routine with the transpose
            [c,I]=sort(a');
            %and transpose the answer
            c=c';
        otherwise
            error(['unsupported option; we recognize only DIM=1 or 2, not ' num2str(DIM)]) 
    end
end
